﻿using System;
using System.Net;
using System.Reflection;
using System.Security.Cryptography.X509Certificates;
using System.Text;

namespace test {
    public class SslConnectionCrashBugDemo {
        private static readonly byte[] data = Encoding.ASCII.GetBytes("test");

        public static void Main(string[] args) {
            // Create listener
            HttpListener listener = new HttpListener();
            // Bind prefix
            listener.Prefixes.Add("https://+:4040/");
            // Set certificate via reflection
            Type hepmType = Type.GetType("System.Net.HttpEndPointManager, System.Net.HttpListener");
            Type heplType = Type.GetType("System.Net.HttpEndPointListener, System.Net.HttpListener");
            MethodInfo getEPListener = hepmType.GetMethod("GetEPListener", BindingFlags.Static | BindingFlags.NonPublic);
            FieldInfo heplCert = heplType.GetField("_cert", BindingFlags.NonPublic | BindingFlags.Instance);
            object epl = getEPListener.Invoke(null, new object[] { "+", 4040, listener, true });
            X509Certificate cert = new X509Certificate2("cert.p12", "changeit");
            heplCert.SetValue(epl, cert);
            // Start listener
            listener.Start();
            Console.WriteLine("Listening, connect to port 4040");
            HttpListenerContext context = listener.GetContext();
            HttpListenerResponse response = context.Response;
            response.StatusCode = (int)HttpStatusCode.OK;
            response.OutputStream.Write(data, 0, data.Length);
            response.OutputStream.Flush();
            response.Close();
            listener.Stop();
        }
    }
}
